---
title: Updating extensions for Firefox 4
slug: Mozilla/Firefox/Releases/4/Updating_extensions_for_Firefox_4
tags:
  - '4'
  - Add-ons
  - Extensions
  - Firefox
  - Firefox 4
  - Gecko 2.0
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}{{Fx_MinVersion_Header(4)}}</p>

<p>This article offers details on changes in Firefox 4 that may impact existing extensions.</p>

<h2 id="User_interface_changes">User interface changes</h2>

<h3 id="The_status_bar">The status bar</h3>

<p>The status bar has been removed from Firefox 4, with a new add-on bar added in its place. See <a href="/en/The_add-on_bar" title="en/The add-on bar">The add-on bar</a> for details.</p>

<h3 id="Toolbars">Toolbars</h3>

<h4 id="Creating_toolbars">Creating toolbars</h4>

<p>If your add-on creates a new toolbar using an overlay, your toolbar may not show up. This happens when your {{XULElem("toolbox")}} element overlay is a child of the {{XULElem("window")}} element instead of a direct child of the overlay element. Move the toolbox out of the window element to fix this problem.</p>

<h3 id="The_Firefox_application_menu">The Firefox application menu</h3>

<p>On Windows, the menu bar is now hidden by default. Instead, there's a single button that opens a simplified Firefox application menu. This menu includes the most used menu features, which makes the application easier to use. The menu bar can still be accessed by pressing the Alt key.</p>

<p>If your add-on is discoverable only through the menu bar, you'll want to overlay the application menu as well. There isn't a specific place to put extension menu items, so you should take a look at the menu and select the right place for your particular extension.</p>

<h3 id="Tabs">Tabs</h3>

<p>A number of changes were made to the {{XULElem("tabbrowser")}} element to help support app tabs and Panoramas, as well as to make the tab bar into a standard toolbar. Other changes that may break existing extensions include:</p>

<ul>
 <li>The <code>TabClose</code>, <code>TabSelect</code>, and <code>TabOpen</code> events no longer bubble up to the {{XULElem("tabbrowser")}} element (<code>gBrowser</code>). Event listeners for those events should be added to <code>gBrowser.tabContainer</code> rather than to <code>gBrowser</code> directly.</li>
 <li>The tab context menu is no longer an anonymous child of the {{XULElem("tabbrowser")}}. It can therefore be overlaid directly with <a href="/en/XUL_Overlays" title="en/XUL Overlays">XUL overlays</a>. It can also be accessed more directly in JavaScript via <code>gBrowser.tabContextMenu</code>. See <a class="external" href="http://www.gavinsharp.com/blog/2010/03/31/accessingmodifying-the-firefox-tab-context-menu-from-extensions/">this blog post</a> for more details.</li>
</ul>

<h2 id="XPCOM_changes">XPCOM changes</h2>

<p>Several changes have been made that affect add-ons and applications that include XPCOM components. See <a href="/en/XPCOM/XPCOM_changes_in_Gecko_2.0" title="en/XPCOM/XPCOM changes in Gecko 2.0">XPCOM changes in Gecko 2</a> for details.</p>

<h2 id="The_Add-on_Manager">The Add-on Manager</h2>

<p>The overhauled Add-on Manager is implemented as a tab instead of in a separate window. Among the changes that affect your browser from a user experience perspective is that your add-on's icon can be 64x64 pixels now instead of 32x32. While 32x32 pixel icons still work, obviously your add-on will look better if it provides a 64x64 pixel icon instead. Fortunately, 64x64 icons are backward compatible and scale down well, so you can just switch instead of needing both sizes.</p>

<p>In addition, the back-end of the Add-on Manager was redesigned. The {{interface("nsIExtensionManager")}} interface is gone, as is the old RDF-based storage it used. Add-on metadata is now stored in an SQLite database, and the Add-on Manager is now a <a href="/en/JavaScript_code_modules">JavaScript code module</a> called <a href="/en/Addons/Add-on_Manager/AddonManager" title="en/Addons/Add-on Manager/AddonManager">AddonManager</a>.</p>

<p>A key difference with the new API is that requesting add-on metadata is now asynchronous instead of synchronous; this applies to add-ons using FUEL as well, so all add-ons that request metadata about add-ons will need to be updated.</p>

<h2 id="Threading">Threading</h2>

<p>You can no longer pass JavaScript objects between threads. This renders the Thread Manager mostly useless for add-on developers, unfortunately, and there aren't at this time many alternatives. It's possible that in the future the <a href="/en/DOM/ChromeWorker" title="en/DOM/ChromeWorker"><code>ChromeWorker</code></a> will be improved to fill the void.</p>

<h2 id="Network_redirects">Network redirects</h2>

<p>The API for handling network redirects has been changed to be asynchronous; any add-ons registering in the "net-channel-event-sinks" category will need to be updated to use <a href="/en/XPCOM_Interface_Reference/nsIChannelEventSink#asyncOnChannelRedirect()" title="en/XPCOM Interface Reference/nsIChannelEventSink#asyncOnChannelRedirect()">the new API</a>.</p>

<h2 id="XPI_unpacking">XPI unpacking</h2>

<p>Firefox 4 <a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=533038">no longer extracts XPIs</a> when installing extensions. It just places the XPI file in the user profile, and then reads the chrome files and others directly out of the XPI. A jar inside the XPI still works, but is no longer necessary, so that can make your development or build easier. This was done mainly for performance reasons on slow OSes, and allows better cache invalidation, which also helps developers. However, not all kinds of files can be read from within the XPI yet, so if your extension uses one of those, you need to specify <span class="nowiki"><a href="https://developer.mozilla.org/en/Install_Manifests#unpack" title="en/Install Manifests#unpack"><code>&lt;em:unpack&gt;</code></a></span> in your install.rdf to cause Firefox to still extract your XPI and use single files, otherwise your extension will fail when trying to access these files.</p>

<p>If your extension only contains these types of files then you do not need to make any changes:</p>

<ul>
 <li><code>install.rdf</code></li>
 <li><code>chrome.manifest</code></li>
 <li><code>chrome</code> (including <code>content</code>, <code>locale</code>, <code>skin</code>)</li>
 <li>default preferences</li>
 <li>XPCOM components written in JavaScript</li>
</ul>

<p>If your extension contains any of the following then you will need to include <code>&lt;em:unpack&gt;</code> in the install.rdf:</p>

<ul>
 <li>Binary XPCOM components</li>
 <li>Shared libraries loaded with ctypes</li>
 <li><code>searchplugins/</code> (which are supposed to be loaded automatically by Firefox)</li>
 <li><code>dictionaries/</code></li>
 <li>Window icons (might get <a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=595462">fixed</a>)</li>
</ul>

<p>If your extension code accesses other files that you have packaged in the XPI then you will either need to include <code>&lt;em:unpack&gt;</code> in the install.rdf or you may be able to support packed installation by making some changes to your code. Any code that used getInstallLocation() and nsIFile will either need em:unpack or needs to be changed. You can use the method <code><a href="/en/Addons/Add-on_Manager/Addon#getResourceURI%28%29">Addon.getResourceURI()</a></code>, it will return an {{interface("nsIURI")}} pointing to the requested file. If the extension is unpacked then it will be a <code><span class="nowiki">file://</span></code> URI. If the extension is packed then it will be a <span class="nowiki"><code>jar://</code></span> URI. You can open streams to these URIs by opening a channel using the {{interface("nsIIOService")}} which will allow you to load the files contents without any unpacking.</p>

<h2 id="Child_HWNDs_have_been_removed">Child HWNDs have been removed</h2>

<p>This should only affect a very small number of developers. In previous versions of Firefox, child <code>HWND</code>s were created on Windows for internal use. As a part of the work toward improving graphics performance, these are no longer created.</p>

<p>Unfortunately, a few extensions have been getting access to these <code>HWND</code>s and manipulating them directly; these extensions will no longer work in Firefox 4. We have put a few hacks in place to help certain pointing-device drivers and assistive technology software (screen readers, for example). However, we have decided against adding even more hacks to support extensions, which should never have been doing this in the first place.</p>

<p>If you maintain an extension that uses native components that rely on <code>HWND</code>s that no longer exist, you'll need to update your extension. There are two ways to do this.</p>

<p>The first, and better, solution is to stop accessing <code>HWND</code>s and instead use Web features or XUL to implement your extension. There are a lot of new features in Firefox 4 that make possible a lot of things that used to require native code, so you may no longer need to do this.</p>

<p>If you find that this doesn't work, and you still need to directly access <code>HWND</code>s, you may find that your only solution is to write an <a href="/en/NPAPI" title="en/NPAPI">NPAPI</a> plugin that does the work. This may be a lot of work, but it should work. Of course, this may not help you if the specific <code>HWND</code>s you were using no longer exist.</p>

<h2 id="Development_and_testing_tips">Development and testing tips</h2>

<h3 id="Caching">Caching</h3>

<p>Because Firefox now caches code and other resources more aggressively, you'll want to be sure to purge the caches when you start up Firefox 4. Otherwise you may be testing obsolete pieces of your add-on. To do this, run Firefox with the <code>-purgecaches</code> command line option.</p>

<h3 id="The_Profile_Manager">The Profile Manager</h3>

<p>The old Profile Manager tool will be getting removed from Firefox 4, although it hasn't been yet. This tool hasn't been updated for a long time and is missing features. On top of that, its presence is slowing down application startup.</p>

<p>A replacement to the profile manager is <a class="link-ftp" href="ftp://ftp.mozilla.org/pub/utilities/profilemanager/">available</a>. (See also {{bug("539524")}}). This new tool is independent of the browser itself, and more robust than the old Profile Manager.</p>

<h3 id="Installing_extensions_globally">Installing extensions globally</h3>

<p>The <code>-install-global-extension</code> and <code>-install-global-theme</code> command line options have been removed. Handling global installation has always been complicated, and discussions are in progress as to how to address the subject going forward. In the meantime, see <a href="/en/Installing_extensions" title="en/Installing extensions">Installing extensions</a> for information on ways to automatically install add-ons.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a class="external" href="http://blog.mozilla.com/addons/2010/11/11/making-add-on-compatible-firefox-4/">Making Your Add-on Compatible with Firefox 4</a> (blog post)</li>
</ul>
